


/*
(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD
        define(['jquery', 'underscore'], factory);
    } else if (typeof exports === 'object') {
        // Node, CommonJS-like
        module.exports = factory(require('jquery'), require('underscore'));
    } else {
        // Browser globals (root is window)
        root.returnExports = factory(root.jQuery, root._);
    }
}(this, function ($, _) {
    
    return {
        ts: ts
    }
}));

*/



/**
 * 
 * 2数相加
 * @param {*} arg1 
 * @param {*} arg2 
 */

function JIA(arg1, arg2) {
    var r1;
    var r2;
    var m;
    try {
        r1 = arg1.toString().split('.')[1].length;
    } catch (e) {
        r1 = 0;
    }
    try {
        r2 = arg2.toString().split('.')[1].length;
    } catch (e) {
        r2 = 0;
    }
    m = Math.pow(10, Math.max(r1, r2));
    return (arg1 * m + arg2 * m) / m;
}


/**
 * 2数相减
 * @param {*} arg1 
 * @param {*} arg2 
 */
function JIAN(arg1, arg2) {
    var r1;
    var r2;
    var m;
    var n;
    try {
        r1 = arg1.toString().split('.')[1].length;
    } catch (e) {
        r1 = 0;
    }
    try {
        r2 = arg2.toString().split('.')[1].length;
    } catch (e) {
        r2 = 0;
    }
    m = Math.pow(10, Math.max(r1, r2));
    //动态控制精度长度
    n = (r1 >= r2) ? r1 : r2;
    return ((arg1 * m - arg2 * m) / m).toFixed(n);
}

/**
 * 2数相除
 * @param {*} arg1 
 * @param {*} arg2 
 */
function SHENG(arg1, arg2) {
    var m = 0;
    var s1 = arg1.toString();
    var s2 = arg2.toString();
    try {
        m += s1.split('.')[1].length;
    } catch (e) {
    }
    try {
        m += s2.split('.')[1].length;
    } catch (e) {
    }
    return Number(s1.replace('.', '')) * Number(s2.replace('.', '')) / Math.pow(10, m);
}

/**
 * 判断是否是微信
 */
function isWx() {
    return /MicroMessenger/i.test(_ua('l')); // 微信
}

function _ua(lower) {
    return lower ? window.navigator.userAgent.toLowerCase() : window.navigator.userAgent;
}



/**
 * vue 下获取参数
 * @param {*} name 
 */
function urlParams(name) {
    var url = "?" + window.location.hash.split("?")[1];
    var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)');
    var result = url.substr(1).match(reg);
    return result ? decodeURIComponent(result[2]) : null;
}


/**
 * 只能为中文
 * @param {*} s 
 */
function iszh(s) {
    var s = $.trim(s);
    var errorchar;
    var badchar = "abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz0123456789><,[]{}?/+=|//:;~!#$%()`";
    errorchar = __iszh( s, badchar)
    if (errorchar != "" ){
        return false;
    }
    return true;
}
function __iszh(s, bag){
    var i,c;
    for (i = 0; i < s.length; i++){
        c = s.charAt(i);
        if (bag.indexOf(c) > -1){
            return c;
        }
    }
    return "";
}


/**
 * 手机号验证
 * @param {*} tel 
 */
function isPhone(tel) {
    var reg =/^1[3|4|5|6|7|8|9][0-9]{9}$/;
    return reg.test(tel);
}

/**
 *  身份证号验证
 * @param {*} idcode 
 */
function isCard(idcode){
    // 加权因子
    var weight_factor = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2];
    // 校验码
    var check_code = ['1', '0', 'X' , '9', '8', '7', '6', '5', '4', '3', '2'];
    var code = idcode + "";
    var last = idcode[17];
    var seventeen = code.substring(0,17);
    var arr = seventeen.split("");
    var len = arr.length;
    var num = 0;
    for(var i = 0; i < len; i++){
        num = num + arr[i] * weight_factor[i];
    }
    
    // 获取余数
    var resisue = num%11;
    var last_no = check_code[resisue];
    var idcard_patter = /^[1-9][0-9]{5}([1][9][0-9]{2}|[2][0][0|1][0-9])([0][1-9]|[1][0|1|2])([0][1-9]|[1|2][0-9]|[3][0|1])[0-9]{3}([0-9]|[X])$/;
    var format = idcard_patter.test(idcode);
    return last === last_no && format ? true : false;
}


/**
 * 对象转数组（axios下需要）
 * @param {*} data 
 * @param {*} isRoot 
 */
function objToArr(data, isRoot=true){
    if(!data || typeof data !== 'object') return data;
    let dataNew = [];
    let keys = Object.keys(data);
    if(keys.includes('0')){
      keys.forEach(k => dataNew[k] = objToArr(data[k], false));
    } else {
      keys.forEach(k => data[k] = objToArr(data[k], false));
    }
    if(isRoot){
      return dataNew.length ? JSON.stringify(dataNew) : JSON.stringify(data);
    } else {
      return dataNew.length ? dataNew : data;
    }
  }



/**
 *  判断是pc还是移动端
 */
  function hasPC() {
    var userAgentInfo = navigator.userAgent;
    var Agents = ['Android', 'iPhone',
      'SymbianOS', 'Windows Phone',
      'iPad', 'iPod'];
    var flag = true;
    for (var v = 0; v < Agents.length; v++) {
      if (userAgentInfo.indexOf(Agents[v]) > 0) {
        flag = false;
        break;
      }
    }
    return flag;
  }

/**
 * 合并列
 * @param {*table id} _w_table_id
 * @param {*第几行} _w_table_colnum
 */
function rowSpan(_w_table_id, _w_table_colnum) {
    var _w_table_firsttd = '';
    var _w_table_currenttd = '';
    var _w_table_SpanNum = 0;
    var _w_table_Obj = $(_w_table_id + ' tr td:nth-child(' + _w_table_colnum + ')');
    _w_table_Obj.each(function(i) {
      if (i === 0) {
        _w_table_firsttd = $(this);
        _w_table_SpanNum = 1;
      } else {
        _w_table_currenttd = $(this);
        if (_w_table_firsttd.text() === _w_table_currenttd.text()) {
          _w_table_SpanNum++;
          _w_table_currenttd.hide(); //remove();
          _w_table_firsttd.attr('rowSpan', _w_table_SpanNum);
        } else {
          _w_table_firsttd = $(this);
          _w_table_SpanNum = 1;
        }
      }
    });
}

/**
 * 合并行
 * @param {table id} _w_table_id
 * @param {第几行} _w_table_rownum
 * @param {*_w_table_maxcolnum：为指定行中单元格对应的最大列数，列数大于这个数值的单元格将不进行比较合并。此参数可以为空，为空则指定行的所有单元格要进行比较合并。}
 */
function colspan(_w_table_id, _w_table_rownum, _w_table_maxcolnum) {
    if (_w_table_maxcolnum === void 0) { _w_table_maxcolnum = 0; }
    var _w_table_firsttd = '';
    var _w_table_currenttd = '';
    var _w_table_SpanNum = 0;
    $(_w_table_id + ' tr:nth-child(' + _w_table_rownum + ')').each(function(i) {
      var _w_table_Obj = $(this).children();
      _w_table_Obj.each(function(i) {
        if (i === 0) {
          _w_table_firsttd = $(this);
          _w_table_SpanNum = 1;
        } else if ((_w_table_maxcolnum > 0) && (i > _w_table_maxcolnum)) {
          return '';
        } else {
          _w_table_currenttd = $(this);
          if (_w_table_firsttd.text() === _w_table_currenttd.text()) {
            _w_table_SpanNum++;
            _w_table_currenttd.hide(); //remove();
            _w_table_firsttd.attr('colSpan', _w_table_SpanNum);
          } else {
            _w_table_firsttd = $(this);
            _w_table_SpanNum = 1;
          }
        }
      });
    });
  }



//测试使用
function ts(num){
        var arr = []
        for(var i=0;i<num;i++){
            arr.push(i)
        }
        return arr;
}

module.exports = {
    ts,
    JIA,
    JIAN,
    SHENG,
    isWx,
    urlParams,
    iszh,
    isPhone,
    isCard,
    objToArr,
    hasPC,
    rowSpan,
    colspan


}



